Graphwavelet  = Graph legend=y dash=0,3 plotcol=${whi},${gre} plotfat=20,13 titlesz=0 labelsz=12 legendsz=16 legendloc='bl' label1="Time (sec)" min2=-500 max2=500 > ${dn}
Graphwavelet1 = Graph legend=y dash=0,3 plotcol=${whi},${gre} plotfat=20,13 titlesz=0 labelsz=12 legendsz=16 legendloc='bl' label1="Time (sec)" min2=-0.05 max2=0.05 > ${dn}
Graphwavelet2 = Graph legend=y dash=0,3,0,3,0,3 plotfat=16,8,16,8,16,8 label1="Time (sec)" > ${dn}
Graphproj = Graph plotfat=9 legend=y legendloc='tl' title="magnetic field projection deviations" label1="Time(sec)" label2="Projection(Teslas)"
Wigglewavelet = Wiggle poly=y zplot=0.3 label1="Time (sec)" wherexlabel=b wheretics=a

# synthetic modeled by1 Kerry1
#${TD}/test.H: ${D}/NR/Test-1col.H
#	Dd < $< esize=4 ein=0  > $@

#testwin: ${TD}/test.H ${B}/firstderiv.x
#	Window < $< n2=1 f2=0 > ${TD}/Rx1.H
#	Window < $< n2=1 f2=1 > ${TD}/Ry1.H
#	Window < $< n2=1 f2=2 > ${TD}/Rz1.H
#	Window < $< n2=1 f2=3 > ${TD}/bx1.H
#	Window < $< n2=1 f2=4 > ${TD}/by1.H
#	Window < $< n2=1 f2=5 > ${TD}/bz1.H
#	
#	${B}/firstderiv.x < ${TD}/Rx1.H > ${TD}/rx1.H
#	${B}/firstderiv.x < ${TD}/Ry1.H > ${TD}/ry1.H
#	${B}/firstderiv.x < ${TD}/Rz1.H > ${TD}/rz1.H
	

matlab = /opt/matlab2011b/bin/matlab -nodesktop -nosplash
pi = 3.14159265358979323844

tBX1=${Xintensity}
tBY1=${Yintensity}
tBZ1=${Zintensity}
tBTOTAL1 = ${TOTintensity}


tBX2=0
tBY2=0
tBZ2=1
tBTOTAL2 = 1

tBX3=0
tBY3=0
tBZ3=1
tBTOTAL3 = 1

tBX4=0
tBY4=0
tBZ4=1
tBTOTAL4 = 1

rad0 = 0.
rad1 = $(shell echo 1.*$(pi)/180. | bc -l)
rad2 = $(shell echo 2.*$(rad1) | bc -l)
rad3 = $(shell echo 3.*$(rad1) | bc -l)
rad4 = $(shell echo 4.*$(rad1) | bc -l)
rad9 = $(shell echo 9.*$(rad1) | bc -l)
rad10 = $(shell echo 10.*$(rad1) | bc -l)
rad45 = $(shell echo 45.*$(rad1) | bc -l)

rad1e1 = $(shell echo $(rad1)*10^-1 | bc -l)
rad1e2 = $(shell echo $(rad1)*10^-2 | bc -l)
rad1e3 = $(shell echo $(rad1)*10^-3 | bc -l)
rad1e4 = $(shell echo $(rad1)*10^-4 | bc -l)
rad1e5 = $(shell echo $(rad1)*10^-5 | bc -l)
rad1e6 = $(shell echo $(rad1)*10^-6 | bc -l)
rad2e6 = $(shell echo $(rad2)*10^-6 | bc -l)
rad1e7 = $(shell echo $(rad1)*10^-7 | bc -l)
rad1e8 = $(shell echo $(rad1)*10^-8 | bc -l)

#bxerr = $(shell echo "-0"$(rad10))
#byerr = $(shell echo "-0"$(rad2))
#bzerr = $(shell echo "-0"$(rad10))

bxerr = 0.02
byerr = -0.02
bzerr = 0.01


${TD}/Morlet-wavelet.H: ${B}/mkmorlet.x
	${B}/mkmorlet.x > $@

#========================
# 1) Silver lake style data
#========================
# generate synthetic rotation data that resembles the silver lake field data in amplitude
# magnetic field equal to the one in silver lake, and rotation mostly around Y.
${TD}/Rx1.H ${TD}/Ry1.H ${TD}/Rz1.H: ${TD}/Morlet-wavelet.H
	Scale < $< rscale=$(rad1e4) > ${TD}/in-theta1.H
	${B}/axisangle2euler.x theta=${TD}/in-theta1.H X=0.1 Y=-0.9. Z=-0.2 euler=${TD}/in-euler1.H > ${dn}
	Window3d < ${TD}/in-euler1.H n2=1 f2=0 > ${TD}/Rx1.H
	Window3d < ${TD}/in-euler1.H n2=1 f2=1 > ${TD}/Ry1.H
	Window3d < ${TD}/in-euler1.H n2=1 f2=2 > ${TD}/Rz1.H

#========================
# 2) Magnetic field =[0 0 1], rotations axis=[1 0 0]
#========================
${TD}/Rx2.H ${TD}/Ry2.H ${TD}/Rz2.H: ${TD}/Morlet-wavelet.H ${B}/axisangle2euler.x
	Scale < $< rscale=$(rad1) > ${TD}/in-theta2.H
	${B}/axisangle2euler.x theta=${TD}/in-theta2.H X=1. Y=0. Z=0. euler=${TD}/in-euler2.H > ${dn}
	Window3d < ${TD}/in-euler2.H n2=1 f2=0 > ${TD}/Rx2.H
	Window3d < ${TD}/in-euler2.H n2=1 f2=1 > ${TD}/Ry2.H
	Window3d < ${TD}/in-euler2.H n2=1 f2=2 > ${TD}/Rz2.H

#========================
# 3) Magnetic field =[0 0 1], rotation axis=[1 1 0.]
#========================
${TD}/Rx3.H ${TD}/Ry3.H ${TD}/Rz3.H: ${TD}/Morlet-wavelet.H ${B}/axisangle2euler.x
	Scale < $< rscale=$(rad1) > ${TD}/in-theta3.H
	${B}/axisangle2euler.x theta=${TD}/in-theta3.H X=1. Y=1. Z=0. euler=${TD}/in-euler3.H > ${dn}
	Window3d < ${TD}/in-euler3.H n2=1 f2=0 > ${TD}/Rx3.H
	Window3d < ${TD}/in-euler3.H n2=1 f2=1 > ${TD}/Ry3.H
	Window3d < ${TD}/in-euler3.H n2=1 f2=2 > ${TD}/Rz3.H

#========================
# 4) Magnetic field =[0 0 1], rotation axis=[1 1 1] 
#========================
${TD}/Rx4.H ${TD}/Ry4.H ${TD}/Rz4.H: ${TD}/Morlet-wavelet.H ${B}/axisangle2euler.x
	Scale < $< rscale=$(rad1) > ${TD}/in-theta4.H
	${B}/axisangle2euler.x theta=${TD}/in-theta4.H X=1. Y=1. Z=1. euler=${TD}/in-euler4.H > ${dn}
	Window3d < ${TD}/in-euler4.H n2=1 f2=0 > ${TD}/Rx4.H
	Window3d < ${TD}/in-euler4.H n2=1 f2=1 > ${TD}/Ry4.H
	Window3d < ${TD}/in-euler4.H n2=1 f2=2 > ${TD}/Rz4.H

# forward modeling of magnetic projections from rotations
${TD}/rx%.H ${TD}/ry%.H ${TD}/rz%.H ${TD}/bx%.H ${TD}/by%.H ${TD}/bz%.H: ${TD}/Rx%.H ${TD}/Ry%.H ${TD}/Rz%.H ${B}/euler_rot.x ${B}/firstderiv.x
	${B}/firstderiv.x < ${TD}/Rx$*.H > ${TD}/rx$*.H
	${B}/firstderiv.x < ${TD}/Ry$*.H > ${TD}/ry$*.H
	${B}/firstderiv.x < ${TD}/Rz$*.H > ${TD}/rz$*.H

	# 3D rotation with Tait-Bryan angles in order X1,Y2,Z3 (wikipedia has a list of various rotation matrices in various orders)
	${B}/euler_rot.x rx=${TD}/Rx$*.H ry=${TD}/Ry$*.H rz=${TD}/Rz$*.H \
	bx=${TD}/tmpbx$*.H by=${TD}/tmpby$*.H bz=${TD}/tmpbz$*.H \
	abx=${tBX$*} aby=${tBY$*} abz=${tBZ$*} > ${dn}
	Math file1=${TD}/tmpbx$*.H exp='file1+${tBX$*}' > ${TD}/bx$*.H
	Math file1=${TD}/tmpby$*.H exp='file1+${tBY$*}' > ${TD}/by$*.H
	Math file1=${TD}/tmpbz$*.H exp='file1+${tBZ$*}' > ${TD}/bz$*.H
	@Rm ${TD}/tmpb[xyz]$*.H 


# what if we got the wrong values for the ambient magnetic field?
# the magnetic data we calculate will be shifted, as if the magnetic axis was pointing somewhere else.
${TD}/s-bx%.H ${TD}/s-by%.H ${TD}/s-bz%.H: ${TD}/bx%.H ${TD}/by%.H ${TD}/bz%.H
	Math file1=${TD}/bx$*.H exp='file1+$(bxerr)*$(tBTOTAL$*)' > ${TD}/s-bx$*.H
	Math file1=${TD}/by$*.H exp='file1+$(byerr)*$(tBTOTAL$*)' > ${TD}/s-by$*.H
	Math file1=${TD}/bz$*.H exp='file1+$(bzerr)*$(tBTOTAL$*)' > ${TD}/s-bz$*.H


# adjoint operator: get rotation angle, axis of rotation and quaternion representation from correct magnetic projections
${TD}/euler%.H: ${TD}/bx%.H ${TD}/by%.H ${TD}/bz%.H ${B}/Rtheta_vector.x
	${B}/Rtheta_vector.x X=${TD}/bx$*.H Y=${TD}/by$*.H Z=${TD}/bz$*.H \
	euler=${TD}/euler$*.H \
	jt=10 eps=1e-30 > ${dn}

# adjoint operator: get rotation angle, axis of rotation and quaternion representation from wrong magnetic projections
${TD}/s-euler%.H: ${TD}/s-bx%.H ${TD}/s-by%.H ${TD}/s-bz%.H ${B}/Rtheta_vector.x
	${B}/Rtheta_vector.x X=${TD}/s-bx$*.H Y=${TD}/s-by$*.H Z=${TD}/s-bz$*.H \
	euler=${TD}/s-euler$*.H \
	jt=10 eps=1e-30 > ${dn}


# get rotations rate from correct magnetic rotations
${TD}/rx%-mag.H ${TD}/ry%-mag.H ${TD}/rz%-mag.H: ${TD}/euler%.H ${B}/firstderiv.x
	Window3d < ${TD}/euler$*.H n2=1 f2=0 > ${TD}/Rx$*-mag.H
	Window3d < ${TD}/euler$*.H n2=1 f2=1 > ${TD}/Ry$*-mag.H
	Window3d < ${TD}/euler$*.H n2=1 f2=2 > ${TD}/Rz$*-mag.H

	${B}/firstderiv.x < ${TD}/Rx$*-mag.H > ${TD}/rx$*-mag.H
	${B}/firstderiv.x < ${TD}/Ry$*-mag.H > ${TD}/ry$*-mag.H
	${B}/firstderiv.x < ${TD}/Rz$*-mag.H > ${TD}/rz$*-mag.H

# get rotations rate from wrong magnetic rotations
${TD}/s-rx%-mag.H ${TD}/s-ry%-mag.H ${TD}/s-rz%-mag.H: ${TD}/s-euler%.H ${B}/firstderiv.x
	Window3d < ${TD}/s-euler$*.H n2=1 f2=0 > ${TD}/s-Rx$*-mag.H
	Window3d < ${TD}/s-euler$*.H n2=1 f2=1 > ${TD}/s-Ry$*-mag.H
	Window3d < ${TD}/s-euler$*.H n2=1 f2=2 > ${TD}/s-Rz$*-mag.H

	${B}/firstderiv.x < ${TD}/s-Rx$*-mag.H > ${TD}/s-rx$*-mag.H
	${B}/firstderiv.x < ${TD}/s-Ry$*-mag.H > ${TD}/s-ry$*-mag.H
	${B}/firstderiv.x < ${TD}/s-Rz$*-mag.H > ${TD}/s-rz$*-mag.H


${TR}/testcomp1:
	Rm ${TD}/R[xyz]1*.H ${TD}/r[xyz]1*.H ${TD}/euler1.H ${TD}/bx1.H 
	make ${TD}/Morlet-wavelet.H
	make ${TD}/Rx1.H 
	make ${TD}/rx1.H 
	make ${TD}/bx1.H 
	make ${TD}/euler1.H
	make ${TD}/rx1-mag.H
	make ${TD}/s-bx1.H 
	make ${TD}/s-euler1.H
	make ${TD}/s-rx1-mag.H

	Merge axis=2 space=n ${TD}/bx1.H ${TD}/by1.H ${TD}/bz1.H | ${Graphproj} curvelabel="bx1:by1:bz1" out=${R}/$(@F)-b.v > ${dn}

	Merge axis=2 space=n ${TD}/Rx1.H ${TD}/Rx1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad" curvelabel="Rx rsensor:Rx mag" out=$@-Rx1.v > ${dn}
	Merge axis=2 space=n ${TD}/Ry1.H ${TD}/Ry1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad" curvelabel="Ry rsensor:Ry mag" out=$@-Ry1.v > ${dn}
	Merge axis=2 space=n ${TD}/Rz1.H ${TD}/Rz1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad" curvelabel="Rz rsensor:Rz mag" out=$@-Rz1.v > ${dn}
	Merge axis=2 space=n ${TD}/rx1.H ${TD}/rx1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad/sec" curvelabel="rx rsensor:rx mag" out=$@-rx1.v > ${dn}
	Merge axis=2 space=n ${TD}/ry1.H ${TD}/ry1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad/sec" curvelabel="ry rsensor:ry mag" out=$@-ry1.v > ${dn}
	Merge axis=2 space=n ${TD}/rz1.H ${TD}/rz1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad/sec" curvelabel="rz rsensor:rz mag" out=$@-rz1.v > ${dn}

	vp_OverUnderAniso $@-Rx1.v $@-Ry1.v $@-Rz1.v > ${R}/$(@F)-Rall.v
	vp_OverUnderAniso $@-rx1.v $@-ry1.v $@-rz1.v > ${R}/$(@F)-rall.v

	Merge axis=2 space=n ${TD}/Rx1.H ${TD}/s-Rx1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad" curvelabel="Rx rsensor:Rx mag" out=$@-s-Rx1.v > ${dn}
	Merge axis=2 space=n ${TD}/Ry1.H ${TD}/s-Ry1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad" curvelabel="Ry rsensor:Ry mag" out=$@-s-Ry1.v > ${dn}
	Merge axis=2 space=n ${TD}/Rz1.H ${TD}/s-Rz1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad" curvelabel="Rz rsensor:Rz mag" out=$@-s-Rz1.v > ${dn}
	Merge axis=2 space=n ${TD}/rx1.H ${TD}/s-rx1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad/sec" curvelabel="rx rsensor:rx mag" out=$@-s-rx1.v > ${dn}
	Merge axis=2 space=n ${TD}/ry1.H ${TD}/s-ry1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad/sec" curvelabel="ry rsensor:ry mag" out=$@-s-ry1.v > ${dn}
	Merge axis=2 space=n ${TD}/rz1.H ${TD}/s-rz1-mag.H | Scale rscale=1e+3 | ${Graphwavelet1} label2="mrad/sec" curvelabel="rz rsensor:rz mag" out=$@-s-rz1.v > ${dn}

	vp_OverUnderAniso $@-s-Rx1.v $@-s-Ry1.v $@-s-Rz1.v > ${R}/$(@F)-s-Rall.v
	vp_OverUnderAniso $@-s-rx1.v $@-s-ry1.v $@-s-rz1.v > ${R}/$(@F)-s-rall.v

	make ${R}/$(@F)-b.pdf ${R}/$(@F)-rall.pdf

${TR}/testcomp%:
	#Rm ${TD}/R[xyz]$**.H ${TD}/r[xyz]$**.H ${TD}/euler$*.H ${TD}/bx$*.H 
	make ${TD}/Morlet-wavelet.H
	make ${TD}/Rx$*.H 
	make ${TD}/rx$*.H 
	make ${TD}/bx$*.H 
	make ${TD}/euler$*.H
	make ${TD}/rx$*-mag.H
	make ${TD}/s-bx$*.H 
	make ${TD}/s-euler$*.H
	make ${TD}/s-rx$*-mag.H

	Merge axis=2 space=n ${TD}/bx$*.H ${TD}/by$*.H ${TD}/bz$*.H | ${Graphproj} min2=-0.12 max2=1.12 curvelabel="bx$*:by$*:bz$*" out=${R}/$(@F)-b.v > ${dn}

	Merge axis=2 space=n ${TD}/Rx$*.H ${TD}/Rx$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad" curvelabel="Rx rsensor:Rx mag" out=$@-Rx$*.v > ${dn}
	Merge axis=2 space=n ${TD}/Ry$*.H ${TD}/Ry$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad" curvelabel="Ry rsensor:Ry mag" out=$@-Ry$*.v > ${dn}
	Merge axis=2 space=n ${TD}/Rz$*.H ${TD}/Rz$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad" curvelabel="Rz rsensor:Rz mag" out=$@-Rz$*.v > ${dn}
	Merge axis=2 space=n ${TD}/rx$*.H ${TD}/rx$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad/sec" curvelabel="rx rsensor:rx mag" out=$@-rx$*.v > ${dn}
	Merge axis=2 space=n ${TD}/ry$*.H ${TD}/ry$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad/sec" curvelabel="ry rsensor:ry mag" out=$@-ry$*.v > ${dn}
	Merge axis=2 space=n ${TD}/rz$*.H ${TD}/rz$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad/sec" curvelabel="rz rsensor:rz mag" out=$@-rz$*.v > ${dn}

	vp_OverUnderAniso $@-Rx$*.v $@-Ry$*.v $@-Rz$*.v > ${R}/$(@F)-Rall.v
	vp_OverUnderAniso $@-rx$*.v $@-ry$*.v $@-rz$*.v > ${R}/$(@F)-rall.v

	Merge axis=2 space=n ${TD}/Rx$*.H ${TD}/s-Rx$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad" curvelabel="Rx rsensor:Rx mag" out=$@-s-Rx$*.v > ${dn}
	Merge axis=2 space=n ${TD}/Ry$*.H ${TD}/s-Ry$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad" curvelabel="Ry rsensor:Ry mag" out=$@-s-Ry$*.v > ${dn}
	Merge axis=2 space=n ${TD}/Rz$*.H ${TD}/s-Rz$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad" curvelabel="Rz rsensor:Rz mag" out=$@-s-Rz$*.v > ${dn}
	Merge axis=2 space=n ${TD}/rx$*.H ${TD}/s-rx$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad/sec" curvelabel="rx rsensor:rx mag" out=$@-s-rx$*.v > ${dn}
	Merge axis=2 space=n ${TD}/ry$*.H ${TD}/s-ry$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad/sec" curvelabel="ry rsensor:ry mag" out=$@-s-ry$*.v > ${dn}
	Merge axis=2 space=n ${TD}/rz$*.H ${TD}/s-rz$*-mag.H | Scale rscale=1e+3 | ${Graphwavelet} label2="mrad/sec" curvelabel="rz rsensor:rz mag" out=$@-s-rz$*.v > ${dn}

	vp_OverUnderAniso $@-s-Rx$*.v $@-s-Ry$*.v $@-s-Rz$*.v > ${R}/$(@F)-s-Rall.v
	vp_OverUnderAniso $@-s-rx$*.v $@-s-ry$*.v $@-s-rz$*.v > ${R}/$(@F)-s-rall.v

	make ${R}/$(@F)-b.pdf ${R}/$(@F)-rall.pdf

