module corr_mod
	implicit none
contains

! convolution and correlation function for floats
	pure subroutine convolveme (f, g, h, n, m)
		integer, intent(in)					:: n, m
		real, dimension(:), intent(in)	:: f, g
		real, dimension(:), intent(out)	:: h
		integer 							:: i, j

		h = 0.
	
		do i = 0, n-1
			do j = 0, m-1
				h (i+j+1) = h (i+j+1) + f(i+1) * g(j+1)
			end do
		end do
	end subroutine

!	subroutine correlateme2 (f, g, h, n, m)
!		integer, intent(in)					:: n, m
!		real, dimension(:), intent(in)	:: f, g
!		real, dimension(:), intent(out)	:: h
!		integer								:: i, j
!	
!		h = 0.
!		do i = 0, n-1
!			do j = m-1, 0, -1
!				h (m - j + i) = h (m - j + i) + f(i+1) * g(j+1)
!				!write (0,*), "h(", m - j + i, ") += f(", i+1, ") * g(", j+1,")"
!			end do
!		end do
!	end subroutine

	pure subroutine correlateme (g, f, h, m, n)
		integer, intent(in)				:: n, m
		real, dimension(:), intent(in)	:: f, g
		real, dimension(:), intent(out)	:: h
		integer							:: i, j

		h = 0.
		do i = 0, m-1
			do j = n-1, 0, -1
				h (n - i + j) = h (n - i + j) + f(j+1) * g(i+1)
				!write (0,*), "h(", n - i + j, ") += f(", j+1, ") * g(", i+1,")"
			end do
		end do
	end subroutine


	pure subroutine correlatehalf (g, f, h, n)
		integer, intent(in)					:: n
		real, dimension(:), intent(in)	:: f, g
		real, dimension(:), intent(out)	:: h
		integer								:: i, j
	
		h = 0.
	
		do i = 0, n-1
			do j = i, n-1
				h (j-i+1) = h (j-i+1) + f(j+1) * g(i+1)
				!write (0,*), "h(", j-i+1, ") += f(", j+1, ") * g(", i+1,")"
			end do
		end do
	end subroutine

end module corr_mod
