! 2nd order first derivative along 1st axis
program firstderiv
	use sep

	implicit none

	real, parameter						:: pi=4.*atan(1.)
	integer, external					:: srite, sreed
	real, allocatable, dimension (:,:,:)	:: Fin
	real, allocatable, dimension (:,:,:)	:: Fout			! output data
	integer								:: n1, n2, n3	! data dimensions
	integer								:: i1, i2, i3	! counters
	real								:: d1, d2, d3, o1, o2, o3, id1
	character (len=256)					:: sfile
	character (len=64)					:: label1, label2, label3
	integer								:: stat
	real, parameter						:: c1 = 2./3., c2=1./12.

	call sep_init()

	call from_history ("n1", n1)
	call from_history ("d1", d1)
	call from_history ("o1", o1)
	call from_history ("label1", label1, "")
	call from_history ("n2", n2, 1)
	call from_history ("d2", d2, 1.)
	call from_history ("o2", o2, 0.)
	call from_history ("label2", label2, "")
	call from_history ("n3", n3, 1)
	call from_history ("d3", d3, 1.)
	call from_history ("o3", o3, 0.)
	call from_history ("label3", label3, "")


	call to_history ("n1", n1)
	call to_history ("d1", d1)
	call to_history ("o1", o1)
	call to_history ("label1", label1)
	call to_history ("n2", n2)
	call to_history ("d2", d2)
	call to_history ("o2", o2)
	call to_history ("label2", label2)
	call to_history ("n3", n3)
	call to_history ("d3", d3)
	call to_history ("o3", o3)
	call to_history ("label3", label3)

	
	call sep_close()

	id1 = 1./d1

	allocate (Fin  (n1, n2, n3))
	allocate (Fout (n1, n2, n3))
	Fin  = 0.
	Fout = 0.

	if (sreed ("in", Fin, n1 * n2 * n3 * sizeof (Fin (1,1,1))) .eq. 0) call seperr ("error reading input");

	do i1=3, n1-2
		Fout (i1, :, :) = id1 * (c1 * (Fin (i1+1, :, :) - Fin (i1-1, :, :))  + c2 * (Fin (i1-2, :, :) - Fin (i1+2, :, :)))
	end do

	if (srite ("out", Fout, n1 * n2 * n3 * sizeof (Fout (1,1,1))) .eq. 0) call seperr ("error writing output");

	deallocate (Fin, Fout)

end program
