program integ
	use sep
	use integ_mod
	implicit none

	integer, external :: sreed, srite
	integer		:: n1, n2, n3, i, j, k
	real		:: o1, o2, o3
	real		:: d1, d2, d3


	real, allocatable, dimension (:,:,:)	:: arr_in, arr_out

	call initpar()

	call from_history ("n1", n1)
	call from_history ("d1", d1)
	call from_history ("o1", o1)
	call from_history ("n2", n2)
	call from_history ("d2", d2)
	call from_history ("o2", o2)
	call from_history ("n3", n3)
	call from_history ("d3", d3)
	call from_history ("o3", o3)

	allocate (arr_in (n1, n2, n3))
	allocate (arr_out (n1, n2, n3))
	
	if (sreed ("in",  arr_in,  n1 * n2 * n3 * sizeof (arr_in(1,1,1)))  .eq. 0) call seperr ("integrot: error reading input file.")

	call integrate_init (n1, o1, d1)

	do j=1,n2
		do k=1,n3
			call integrate (arr_in (:, j, k), arr_out (:, j, k))
		end do
	end do

	call to_history ("n1", n1)
	call to_history ("d1", d1)
	call to_history ("o1", o1)
	call to_history ("n2", n2)
	call to_history ("d2", d2)
	call to_history ("o2", o2)
	call to_history ("n3", n3)
	call to_history ("d3", d3)
	call to_history ("o3", o3)

	if (srite ("out",  arr_out,  n1 * n2 * n3 * sizeof (arr_out(1,1,1)))  .eq. 0) call seperr ("integrot: error writing output file.")

	deallocate (arr_in, arr_out)


end program
